
! for WithOneHand() function
Global withonehandflag = false;

Object sc_2
  class Scene,
  with
	number 2,
	init_scene [;
		SetQuestion(q2_1);
	],
	begin_scene [ rock;
		switch (rock) {
			1: ! first time in
				GiveInitialTools();
				move activeplayer to WhiteJunction;
				give WhiteJunction ~general;
				withonehandflag = false;
				SaveToolPositions();
			2, -1, -2: ! all subsequent times (including boom/splat)
				move activeplayer to WhiteJunction;
				give WhiteJunction ~general; ! seen it once
				withonehandflag = false;
				give cornerdoor ~open;
				move boltwrench to largecrate;
				RestoreToolPositions();
				give panelhole ~general;	! not bloodied
				remove blood;				! ditto
				! yeah, RestoreToolPositions should get this, but anyway
				move package to panelcache;	
		}
	],
	end_scene [ rock subrock   var;
		switch (rock) {
			-1:
				SetAcidQuestions(subrock);
			-2:
				SetBlastQuestions(subrock);
			-3: ! security door open
				switch (subrock) {
					1:
						SetQuestion(q2_o1);
					2:
						SetQuestion(q2_o2);
					default:
						print " ,   . -! []^";
				}
			1: ! wrench set off metal-scan
				if (q2_d1 hasnt general) {
					give q2_d1 general;
					SetQuestion(q2_d1, subrock);
				}
				else if (q2_d1r hasnt general) {
					give q2_d1r general;
					SetQuestion(q2_d1r, subrock);
				}
				else {
					SetQuestion(q2_d1rr, subrock);
				}
			2: ! no scan problems, but walked into guards
				SetQuestion(q2_d2);
			3: ! with wrench and scrambler
				if (q2_d3 hasnt general) {
					give q2_d3 general;
					SetQuestion(q2_d3, subrock);
				}
				else {
					SetQuestion(q2_d3r, subrock);
				}
			4: ! moved wrench
				SetQuestion(q2_d4);
			5: ! left tools behind
				SetQuestion(q2_d5, subrock);
			6: ! no blood
				if (q2_d6 hasnt general) {
					give q2_d6 general;
					SetQuestion(q2_d6);
				}
				else {
					var = (package has moved);
					SetQuestion(q2_d6r, var);
				}
			7: ! blood, but player/man never saw package
				if (q2_d7 hasnt general) {
					give q2_d7 general;
					SetQuestion(q2_d7);
				}
				else {
					SetQuestion(q2_d7r);
				}
			8: ! blood, but player left package behind (in ceiling)
				SetQuestion(q2_d8);
			9: ! blood, but player left package behind (elsewhere)
				SetQuestion(q2_d9);
			10: ! left anything in panelcache
				if (q2_d10 hasnt general) {
					give q2_d10 general;
					SetQuestion(q2_d10, subrock);
				}
				else {
					SetQuestion(q2_d5, subrock);
				}
			20: ! success
				SetScene(sc_3);
		}
	];

Object q2_1
  class Question,
  with
	query "^     . @<<,  .       @>>.    . @<<    ,      ?@>>",
	time_limit 3,
	answer_yes [; 
		print " . @<<    .        ,    .";
		SetQuestion(q2_2);
	],
	answer_no [;
		print "@<<, .     .";
		SetQuestion(q2_2);
	],
	answer_wait [;
		if (num_no_answers + num_yes_answers == 0) {
			print "    ,     ...  ,   . @<<  - .    . ";
		}
		else if (num_wait_answers <= 1) {
			print "  . @<< ...  ,     .  ";
		}
		else {
			print "@<< , .  ";
		}
		print "   ,       .";
		SetQuestion(q2_2);
	];

Object q2_2
  class Question,
  with
	query " , --  , --        @>>.",
	time_limit 2,
	answer_yes [;
		print "@<<- ?  ,     @>>.   ,  . @<<.    ...@>>^";
		BeginScene(1);
	],
	answer_no [;
		print "@<<@>>.    . @<<.    ...@>>^";
		BeginScene(1);
	],
	answer_wait [;
		print "  . @<<?   ,         ,    ", (emphstring) "", " .  @>>.    . @<<.    ...@>>^";
		BeginScene(1);
	];

Object q2_d1
  class Question,
  with
	query "^@<<        ?    ,   -  ?@>>",
	time_limit 4,
	answer_yes [;
		num_blatant_lies++;
		print "@<<, .     ,     .    @>>.^";
		BeginScene(2);
	],
	answer_no [;
		print "@<<, .     ,    .    @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		num_blatant_lies++;
		print "   . @<<     --  ,   --     .    @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q2_d1r
  class Question,
  with
	query "^@<<   .     ,    .  ,   ,       @>>.",
	time_limit 3,
	answer_yes [;
		num_got_angry++;
		num_helpfuls++;
		print "@<<  ";
		if (self.variant == 0)
			print " ";
		else
			print " ";
		print "   .    @>>.     ,  .^";
		BeginScene(2);
	],
	answer_no [;
		num_got_angry++;
		num_stupids++;
		print "@<< .   ";
		if (self.variant == 0)
			print " ";
		else
			print " ";
		print "   .    @>>.     ,  .^";
		BeginScene(2);
	],
	answer_wait [;
		num_got_angry++;
		num_stubborns++;
		print "@<< .    ,   ";
		if (self.variant == 0)
			print " ";
		else
			print " ";
		print "   .    @>>.     ,  .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked
	
Object q2_d1rr
  class Question,
  with
	query [;
		print "^@<< .            @>>.    ,    .^";
		BeginScene(2);
	];

Object q2_d2
  class Question,
  with
	query "^  . @<<     ,    .   ?@>>",
	time_limit 1,
	answer_yes [;
		print "  .^";
		BeginScene(2);
	],
	answer_no [;
		num_stubborns++;
		print "@<<   @>>.   .^";
		BeginScene(2);
	],
	answer_wait [;
		print "  .^";
		BeginScene(2);
	];

Object q2_d3
  class Question,
  with
	query [;
		print "^@<<...        .  ,     @>>.      ,   . @<< ,     .   ,     ,   .   . ,    , ,       ,   ?       ...  @>>.^^@<<      ,    ";
		if (self.variant == 0)
			print " ";
		else
			print " ";
		print "    .  @>>.^";
		rtrue;
	],
	time_limit 5,
	daemon [;
		if (self.number == 2) {
			print "^@<<... ?@>>^";
		}
	],
	! swapped yes/no [yan]
	answer_no [;
		num_stupids++;
		num_sneaky_lies++;
		print "    . @<<   ,     , --  , --        @>>.   .^";
		BeginScene(2);
	],
	answer_yes [;
		num_helpfuls++;
		print "     . @<<   , --  , --        @>>.   .^";
		BeginScene(2);
	],
	answer_wait [;
		print "     . @<<   , --  , --        @>>.   .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q2_d3r
  class Question,
  with
	query [;
		print "^@<<   .          ,     ", (emphstring) "", ",    @>>.    ,    .^";
		BeginScene(2);
	];

Object q2_d4
  class Question,
  with
	query [;
		print "^@<<,  ,    ,          ";
		if (boltwrench in smallcrate)
			print " ";
		print " .    .      ,     @>>.^";
		BeginScene(2);
	];

Object q2_d5
  class Question,
  with
	query [;
		print "^@<<,  ,     .";
		if (self.variant == 1)
			print "    ";
		else
			print "     ", (cNom) self.variant, ",   ";
		! print "";
		print ".   ,      @>>.^";
		BeginScene(2);
	];

Object q2_d6
  class Question,
  with
	query "^@<< ,     @>>.     . @<<       ,    .     ,           - .  ,       ?@>>",
	time_limit 6,
	daemon [;
		if (self.number == 4) {
			print "^       .^";
		}
	],
	answer_yes [;
		num_stubborns++;
		print "@<<? ,    ...@>> ,  . @<< ~   .~ ? ,  @>>.^";
		BeginScene(2);
	],
	answer_no [;
		num_helpfuls++;
		print "@<< ,      .   @>>.^";
		BeginScene(2);
	],
	answer_wait [;
		num_stubborns++;
		print "  . @<< . ,    ...@>> ,  . @<< ~   ,~ ? ,  @>>.^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q2_d6r
  class Question,
  with
	query [;
		print "^@<<     .  ,    ";
		if (self.variant == 0)
			print " ,   .      ?@>>";
		else
			print "   @>>.";
		print "    ,    .^";
		BeginScene(2);
	];

Object q2_d7
  class Question,
  with
	query "^   . @<<, .      ,    ,    ,  ,  @>>.",
	time_limit 2,
	answer_yes [;
		num_got_angry = num_got_angry + 2;
		num_stubborns++;
		num_sneaky_lies++;
		print "@<<, ", (emphstring) ",", ", --        . -- ,  ,   ?  ?     - ", (emphstring) ",", "    ,    .     ,    .    ,  - .   , ", (emphstring) "", "@>>.     .^";
		BeginScene(2);
	],
	answer_no [;
		num_got_angry = num_got_angry + 2;
		num_stubborns++;
		print "@<<", (emphstring) "?", "  , --        . --     ?@>>  . @<<    ,    .    ,  - .   , ", (emphstring) "", "@>>.     .^";
		BeginScene(2);
	],
	answer_wait [;
		num_got_angry = num_got_angry + 2;
		num_stubborns = num_stubborns + 2;
		print "@<<", (emphstring) " ", "   , --  ,      . -- ,  ,   ?  ?     - ", (emphstring) ",", "    ,    .     ,    .    ,  - .   , ", (emphstring) "", "@>>.     .^";
		BeginScene(2);
	],
  has ~general; ! general means it's been asked

Object q2_d7r
  class Question,
  with
	query [;
		print "^@<<   , --  ,  . --   @>>, --   .^";
		BeginScene(2);
	];

Object q2_d8
  class Question,
  with
	query [;
		print "^@<<, ,  ... ", (emphstring) "", "     .       ,     @>>.   .^";
		BeginScene(2);
	];

Object q2_d9
  class Question,
  with
	query [;
		print "^@<<, ,      .       ,     @>>.   .^";
		BeginScene(2);
	];

Object q2_d10
  class Question,
  with
	query [;
		print "^@<< ,  ,  ,         ?";
		if (q2_d7 hasnt general)
			print "   ,  .";
		else
			print "  ,    .";
		if (self.variant == 1)
			print "    ";
		else
			print "     ", (cAcc) self.variant, ",   ";
		print "@>>.    ,    - .^";
		BeginScene(2);
	]
  has ~general; ! general means it's been asked

Object q2_o1
  class Question,
  with
	query [;
		print "^@<<,    --  ,   -- ,   ,   , .      ,    .       ,     ,    @>>.   .^";
		BeginScene(2);
	];

Object q2_o2
  class Question,
  with
	query [;
		print "^@<<  - .     ,     .      ,     @>>.   . @<<   --  ,       @>>.   .^";
		BeginScene(2);
	];


! ------------- The gun-hiding scene

Object WhiteJunction " "
  with
	description [;
		if (self hasnt general) {
			give self general;
			print "  ";
		}
		else {
			print " ";
		}
		print "   ,   ,    .    , ";
		if (powercut == 0)
			print " ";
		else
			print "  ";
		"  .       ; , ,   -.";
	],
	se_to [;
		print "    ,    .^";
		return InsideEntrance;
	],
	e_to SouthBoundary,
	n_to CeilingHole,
  has ~general;		! general means you've looked once.

Object InsideEntrance "  "
  with
	description [;
		print "   ,     .";
		if (escaping == 0)
			print "   , ";
		else
			print " ";
		print "      .^";
		rtrue;
	],
	w_to outerdoorin,
	out_to outerdoorin,
	n_to WhiteJunction,
	nw_to WhiteJunction;

! Matched with outerdoor in t-1.
Object -> outerdoorin "/ /"
  with
	name '' '' '' '' '' '',
	description "   ,   30  ,      .      ,  ,  .",
	door_dir w_to,
	door_to InsideEntrance,
	door_try [;
		PronounNotice(self);
		"   .";
	],
	before [;
		Open: 
			"   .";
		Close:
			if (self hasnt open)
				"  .";
		Attack, KnockOn: 
			"      .     --        .";
		Push, Turn: 
			"  .^";
		Pull: 
			"    ,       .";
		Touch, Rub: 
			"    .";
		ActivateTool:
			if (escaping)
				"^    . ...  . []";
			if (location == InsideEntrance)
				print "^   ,      .      , ,  ,   .^";
			else
				print "^ .           .^";
			EndScene(-3, 1);
			rtrue;
	],
  has scenery door ~open female;

Object -> outerdoorinplate "/ /  ",
  class InteriorPlate,
  with
	work_target outerdoorin;

Object CeilingHole "  "
  with
	description [;
		print "       .       ,  .      , ";
		if (cornerdoor has open)
			print " ";
		else
			print " ";
		print ".";
		new_line;
		if (player in panelhole) {
			print "^     ,   .     ,     30   .^";
		}
		rtrue;
	],
	n_to cornerdoor,
	w_to cornermetaldoor,
	s_to WhiteJunction,
	e_to NorthBoundary,
	in_to [; <<Enter panelhole>>; ];

Object -> cornerdoor "/ /"
  with
	name '' '' '//' '' '' '' '' '' '',
	door_dir n_to,
	door_to StorageCloset,
	door_try [;
		if (self hasnt open)
			"   .";
	],
	description [;
		print "    --  ,   ,       ,  . ";
		if (self has open)
			print " ";
		else
			print " ";
		".";
	],
  has scenery door ~open openable female;
	
Object -> cornermetaldoor "/ /"
  class InteriorDoor,
  with
	name '//' '' '',
	description "   ,    .        .  .",
	door_dir w_to,
	before [;
		ActivateTool:
			if (escaping)
				"^ ,    . []";
			if (location == CeilingHole)
				print "^    .       .            ;       .           .^";
			else
				print "^ .           .^";
			EndScene(-3, 2);
			rtrue;
	],
  has scenery door ~open female;

Object -> cornermetaldoorplate "/ /  "
  class InteriorPlate,
  with
	work_target cornermetaldoor;

Object -> concreteceiling "/ /"
  with
	name '' '' '' '' '',
	description "       .",
	before [;
		Examine, Search:
			rfalse;
		Touch, Rub:
			if (player notin panelhole)
				"   .";
			"   .";
		default:
			if (player notin panelhole)
				"   .";
			rfalse;
	],
  has scenery male;

Object -> supervent "/ "
  with
  	name '' '' '' '' '' '', ! <- let's hope this doesn't break things
    !parse_name [ num wd;
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, ventilator, name) ~= 0)) {
	!		num++;
	!		wd = NextWord();
	!	} 
	!	return num;
	!],
	description [;
		if (self hasnt open)
			<<Examine ventilator>>;
		print "  ,   ,   .  ";
		if (player notin panelhole)
			",        ,  .";
		if (child(self)) {
			print ".     ";
            if (children(self) > 1) 
                print "";
            else
                print "";
			WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		}
		else {
			";     .";
		}
	],
	before [ fn;
		Examine:
			rfalse;
		Search:
			if (self hasnt open)
				<<Search ventilator>>;
			if (player notin panelhole)
				"       .";
			if (child(self)) {
				print "    ";
				WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
				".";
			}
			else {
				" , , .";
			}
		Enter:
			if (player notin panelhole)
				<<Touch ventilator>>;
			"    30  .";
		EmptyT:
			if (player notin panelhole)
				<<Touch ventilator>>;
			"       .";
		Empty:
			if (player notin panelhole)
				<<Touch ventilator>>;
			if (self hasnt open)
				rfalse;
			if (child(self) == nothing)
				"      .";
			print "     ...^";
		Open:
			if (self has open)
				print_ret (CCNom) self, "  .";
			if (player notin panelhole)
				<<Touch ventilator>>;
			if (~~escaping) {
				if (self hasnt general) {
					give self general;
					fn = emphstring;
				}
				else {
					fn = normstring;
				}
				fn("    .");
				new_line;
				rtrue;
			}
			give self open;
			print "         ...   ,  .    .    ,  ,  , , .^";
			if (child(self)) {
				print "^  ";
				WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
				print ".^";
			}
			rtrue;
		Close:
			if (self hasnt open)
				print_ret (CCNom) self, "  .";
			if (player notin panelhole)
				<<Touch ventilator>>;
			give self ~open;
			"   ,      .";
		Listen:
			<<Listen ventilator>>;
		ThrownAt:
			rfalse;
		default: ! including LetGo
			if (player notin panelhole)
				<<Touch ventilator>>;
			rfalse;
	],
  has scenery container ~open female; ! general means italic warning

Object -> panelhole "/"
  with
	name '' '' '' '' '' '' '' '' '' '',
	describe [;
		"^     ,   .";
	],
	description [;
		if (player in self)
			<<Examine panelcache>>;
		print "  60  90 .      ,   10    .";
		if (self has general)
			print "        .";
		new_line;
		rtrue;
	],
	vehicle_name " (  )",
	vehicle_status_name ",   ",
	ceiling_reachable true,
	react_before [;
		Jump:
			if (player in self)
				"    ,    .";
			move player to self;
			move panelcache to self;
			self.number = 0;
			print "    .     ,     .      30   .^";
			if (self hasnt general) {
				give self general;
				move blood to location;
				print "^", (emphstring) "!", "       .     ,        .^";
			}
			rtrue;
		Exit:
			if (player in self) {
				move player to location;
				remove panelcache;
				print "    ";
				if (self.number >= 3 && self.number < 5)
					print "   ";
				if (self.number >= 5 && self.number < 8)
					print "    ";
				else if (self.number >= 8)
					print "    ";
				".";
			}
		Go:
			if (noun == u_obj or in_obj)
				<<Enter self>>;
			if (player notin self)
				rfalse;
			if (noun == d_obj or out_obj)
				<<Exit>>;
			"   .";
		Open, Close, Take, Set, SetTo, Turn, Push, Pull, Touch, Switchon, Switchoff,
			Attack, Empty:
			if (player notin self)
				rfalse;
			if (UnreachableHanging(noun))
				"  ,         .";
			if (noun == supervent)
				rfalse;
			if (action == ##Pull && noun == panelhole)
				rfalse;
			WithOneHand();
			rfalse;
		AttackWith:
			if (player notin self)
				rfalse;
			if (second && second ofclass PulseGun)
				rfalse;
			if (UnreachableHanging(noun))
				"    ", (cGen) noun, ",        .";
			if (UnreachableHanging(second))
				"    ", (cGen) second, ",        .";
			WithOneHand();
			rfalse;
		Tie, Detach, BaseTouchTo, Lock, Unlock:
			if (player notin self)
				rfalse;
			if (UnreachableHanging(noun))
				"    ", (cGen) noun, ",        .";
			if (UnreachableHanging(second))
				"    ", (cGen) second, ",        .";
			WithOneHand();
			rfalse;
		Drop:
			if (player notin self)
				rfalse;
			if (noun == self)
				<<Exit>>;
			! duplicate DropSub, sort of
			if (noun in location) print_ret (CCNom) noun, "  ", (V2aEnd) noun, " .";
			if (noun notin player) return L__M(##Drop,2,noun);
			if (noun has worn) {
				L__M(##Drop,3,noun);
				<Disrobe noun>;
				if (noun has worn) rtrue;
			}
			move noun to location;
			print_ret (CCNom) noun, " ", (V1bEnd) noun, " .";
		Insert, PutOn:
			if (second == self) {
				if (noun == player)
					rfalse;
				if (player notin self)
					print_ret (string) HoleOutOfReach;
				<<(action) noun panelcache>>;
			}
			if (player notin self)
				rfalse;
			if (UnreachableHanging(noun))
				"    ", (cGen) noun, "        .";
			if (UnreachableHanging(second))
				"    ", (cGen) second, "        .";
			WithOneHand();
			rfalse;
		WaveHands:
			if (player in self)
				"    .";
	],
	before [;
		Enter, Climb:
			if (player in self) {
				"       - 10  --    .";
			}
			else {
				print_ret (string) HoleOutOfReach;
			}
		Empty:
			if (player notin self)
				print_ret (string) HoleOutOfReach;
			<<Empty panelcache>>;
		Search:
			if (player notin self)
				"            .";
			<<Search panelcache>>;
		EmptyT:
			if (player notin self)
				print_ret (string) HoleOutOfReach;
			"       .";
		Touch, Push, Turn:
			if (player notin self)
				print_ret (string) HoleOutOfReach;
			rfalse;
		Pull:
			if (player notin self)
				print_ret (string) HoleOutOfReach;
			<<Search panelcache>>;
		Take:
			if (player notin self)
				print_ret (string) HoleOutOfReach;
			else
				"     .";
	],
	number 0, ! for each_turn 
	each_turn [;
		withonehandflag = false;
		if (player in self) {
			self.number++;
			switch (self.number) {
				3:
					if (random(11) <= 5)
						"^    ,   .";
					else
						"^      ,   .";
				5: 
					print "^       .";
					if (powercut == 0)
						print "          .";
					new_line;
					rtrue;
				8: "^     .";
				12: "^   .";
				16: "^         .   .";
			}
		}
	],
  has static enterable open container ~general female; ! general means bloodied

Constant HoleOutOfReach "  30   .";

[ WithOneHand;
	if (withonehandflag)
		rtrue;
	withonehandflag = true;
	"( ,  )";
];

[ UnreachableHanging obj;
	if (player notin panelhole) {
		print "      ! []^";
		rfalse;
	}
	if (obj == nothing)
		rfalse;
	if (obj == player)
		rfalse;
	if (obj == panelhole or panelcache or concreteceiling or lowceiling
		or blood or supervent)
		rfalse;
	if (anywherein(obj, panelcache))
		rfalse;
	if (supervent has open && anywherein(obj, supervent))
		rfalse;
	if (anywherein(obj, player))
		rfalse;
	rtrue;
];

Object panelcache "/"  ! exists only to be the panel storage thingie
  with
  	! no name, except for debugging purposes
  	! name 'cache',
	describe [;
		if (player notin panelhole)
			"^     ! []";
		rtrue;
	],
	description [;
		<<Search self>>;
	],
	before [;
		Search:
			print ",       ,        .        10 ,       .";
			if (package in self)
				give package moved;
			if (child(self) == nothing) {
				"^^   ,  .";
			}
			if (child(self) == package && children(self) == 1) {
				"^^ ,  ,          .";
			}
			print "^^   ";
			WriteListFrom(child(self), TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		Examine, Receive, LetGo:
			rfalse;
		Empty:
			if (child(self) == nothing)
				"       .";
			if (package in self)
				give package moved;
			print "     ...^";
		default:
			"You can't refer to the hole that way. []";
	],
	after [;
		Receive:
			print_ret "  ,   ", (cAcc) noun, "   .";
	],
  has scenery container open female;

Object package "/ /" panelcache
  with
	name '' '' '' '' '' '',
	description "   ,    .",
	before [;
		Touch:
			",     --    .";
		Open, Search:
			"  .";
		Receive, Empty, EmptyT:
			"    .";
		Take, Drop:
			give self moved;
			rfalse;
	],
	data_cache 0,
	save_pos [ ptr;
		ptr = self.&data_cache;
		ptr-->0 = parent(self);
	],
	restore_pos [ ptr;
		ptr = self.&data_cache;
		set_parent(self, ptr-->0);
	],
	escape_pos [ loc;
		loc = 0;
		remove self;
	],
  has ~moved male; ! moved means you've seen it (at all)
	
Object blood "/ /"
  with
	name '' '' '' '' '' '',
	description "            .",
	before [;
		Examine, Search:
			rfalse;
		Take, Touch, Rub:
			if (player notin panelhole)
				"     .";
			" ,    ,    .";
		default:
			if (player notin panelhole)
				"     .";
			rfalse;
	],
  has scenery neuter;

Object gun "/" supervent
  class PulseGun,
  with name "",
	article "",
	description "    ,  ,   .   ,   .",
	answer_general [;
		if (self hasnt general) {
			give self general;
			print "   .^^";
		}
		rtrue;
	],
  has ~general male; ! used for the goofy message

Object StorageCloset ""
  with
	description [;
		print " , ,    --  ,      ,  .  ";
		if (cornerdoor has open)
			print " ";
		else
			print " ";
		print ".^^      .";
		new_line;
		rtrue;
	],
	s_to cornerdoorback,
	out_to cornerdoorback,
	cant_go "  --  .";

Object -> cornerdoorback "/ /"
  with
	name '' '' '' '//' '',
	door_dir s_to,
	door_to CeilingHole,
	door_try [;
		if (cornerdoor hasnt open)
			" .";
	],
	description [;
		print " ";
		if (cornerdoor has open)
			print " ";
		else
			print " ";
		".";
	],
	before [;
		Open: <<Open cornerdoor>>;
		Close: <<Close cornerdoor>>;
	],
  has scenery door open female;	! use cornerdoor for open-testing

Class StorageCrate
  with
	name '' '' '' '',
	describe [;
		rtrue;
	],
	ceiling_reachable true,
	react_before [;
		Exit:
			if (player in self) {
				move player to parent(self);
				if (keep_silent == 0)
					print "   ", (cGen) self, ".^";
				rtrue;
			}
		Go:
			if (player in self && noun == d_obj)
				<<Exit>>;
	],
	before [;
		Search:
			print_ret (CCNom) self, " .";
		Open:
			print_ret (CCNom) self, "  .       .";
		Unlock:
			if (second == boltwrench)
				"  ,   .";
			print_ret (CCNom) second, "     .";
		Close:
			"  .";
		Push, PushDir, Pull, Turn:
			<<Take self>>;
		Take:
			print_ret (CCNom) self, "    .";
		LookUnder:
			print_ret "     ", (cAcc) self, ".";
		Receive:
			if (receive_action == ##Insert)
				print_ret (CCNom) self, " .";
		Climb:
			<<Enter self>>;
		Empty, EmptyT:
			print_ret (CCNom) self, " .";
	],
	after [;
		Enter:
			print_ret "   ", (cAcc) self, ".";
	],
  has scenery supporter enterable male;

Object -> largecrate "/ /"
  class StorageCrate,
  with
	name '' '';

Object -> smallcrate "/ /"
  class StorageCrate,
  with
	name '' '',
	before [;
		Take:
			"    .";
	];

Object boltwrench "/ /" largecrate
  with
	name '' '' '' '',
	description "   .",
	has male;

Constant CrossLine "        .^";

[ TryCrossLine rightspot   ix;

	if (anywherein(boltwrench, player)) {
		if (anywherein(scrambler, player) && scrambler has general) {
			print (string) CrossLine;
			EndScene(3, 0);
			rtrue;
		}
	
		print "     ,      .^";
		EndScene(1, 0);
		rtrue;
	}
	
	if (rightspot == 0) {
		print "  ,     ...      ,    .^";
		EndScene(2);
		rtrue;
	}
	
	if (panelhole hasnt general) {
		! no blood
		print (string) CrossLine;
		EndScene(6);
		rtrue;
	}
	
	if (package hasnt moved) {
		! blood, but player/man never saw package
		print (string) CrossLine;
		EndScene(7);
		rtrue;
	}
	
	if (~~(anywherein(package, player))) {
		! blood, but player left package behind
		print (string) CrossLine;
		if (package in panelcache)
			EndScene(8);
		else
			EndScene(9);
		rtrue;
	}
	
	if (~~(boltwrench in largecrate)) {
		print (string) CrossLine;
		EndScene(4);
		rtrue;
	}
	
	ix = child(panelcache);
	if (ix) {
		if (children(panelcache) > 1)
			ix = 1;
		print (string) CrossLine;
		EndScene(10, ix);
		rtrue;
	}
	
	ix = LeftToolsBehind();
	if (ix) {
		print (string) CrossLine;
		EndScene(5, ix);
		rtrue;
	}
	
	! happy ending
	print (string) CrossLine;
	EndScene(20);
	rtrue;
];

Object SouthBoundary " "
  with
	description [;
		"          .     -      .       .";
	],
	w_to WhiteJunction,
	se_to [;
		if (escaping) {
			return SouthFrontier;
		}
		return TryCrossLine(1);
	];

Object NorthBoundary " "
  with
	description [;
		"          .     -      .       .";
	],
	w_to CeilingHole,
	se_to [;
		if (escaping) {
			return SharpCorner;
		}
		return TryCrossLine(0);
	];

Object boundaryline "/ /"
  with
	name '' '' '' '' '' '' '' '',
	found_in SouthBoundary NorthBoundary,
	description [;
		print "   ,      -  . ";
		if (location == NorthBoundary)
			print " ";
		"   .";
	],
	react_before [;
		ThrowDir:
			if (escaping == 0) {
				if (noun == boltwrench && second == se_obj)
					<<ThrowAt noun self>>;
			}
	],
	before [;
		Enter, JumpOver:
			<<Go se_obj>>;
		Rub:
			"   .";
		ThrownAt:
			if (escaping == 0 && noun == boltwrench) {
				if ((anywherein(scrambler, location) && scrambler has general)) {
					print "     .^";
					EndScene(3, 1);
				}
				else {
					print "     ,       .^";
					EndScene(1, 1);
				}
				rtrue;
			}
	],
  has scenery female;

Object boundaryweb "/ /"
  with
	name '' '' '' '',
	found_in SouthBoundary NorthBoundary,
	description " -,    , ,     ,   .        .",
	before [;
		Examine:
			rfalse;
		default:
			"     -.   .";
	],
  has scenery female;

