
Fake_Action ActivateTool;
Fake_Action DeactivateTool;

Global SeenDoorsPitted = 0; ! set if you've acid-sprayed any doors
Global heard_timer_warning = 0;
Global giveinittoolsflag = 0;
! ------------- Tools

Object toolcase "/  "
  with
	name '' '' '' '',
	describe [;
		if (self hasnt open)
			"^     ,  .";
		if (child(self) == nothing)
			"^     ,  ,     .";
		print "^     .  ";
		WriteListFrom(child(self),
			ISARE_BIT + TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
		".";
	],
	description [;
		print "         ";
		if (self hasnt open)
			";   .";
		print "     . ";
		<<Search self>>;
	],
	partinvent [;
		if (inventory_stage == 2) {
			if (self hasnt open)
				rtrue;
		}
	],
	invent [;
		if (inventory_stage == 2) {
			if (self hasnt open)
				rtrue;
		}
	],
	add_to_scope [;
		if (self has open) {
			PlaceInScope(toolcasefoam);
			PlaceInScope(toolcasehollows);
		}
	],
	react_before [ ix;
		if (~~(voicetrans in self && self hasnt open))
			rfalse;
		switch (action) {
			##Tango:
				<<ActivateTool voicetrans>>;
			##Waltz:
				<<DeactivateTool voicetrans>>;
			##VagueSay, ##Answer:
				if (consult_words >= 1) {
					wn = consult_from;
					ix = NextWord();
					if (ix == '~//' && consult_words >= 2) {
						ix = NextWord();
					}
					if (ix == '') {
						<<ActivateTool voicetrans>>;
					}
					if (ix == '') {
						<<DeactivateTool voicetrans>>;
					}
				}
		}
	],
	before [;
		Open:
			if (noun has open)
				print_ret "    .";
			give noun open;
			if (child(self) == nothing)
				"    ,    .";
			print "    . ";
			WriteListFrom(child(self),
				ISARE_BIT + TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		Search:
			if (self hasnt open)
				print_ret "   .";
			if (child(self) == nothing)
				print_ret "   .";
			print "   ";
			WriteListFrom(child(self),
				ISARE_BIT + TERSE_BIT + ENGLISH_BIT + PARTINV_BIT);
			".";
		Receive:
			if (self hasnt open)
				rfalse;		! for default closed message
			if (noun == lockpick)
				rfalse;
			if (noun ofclass ToolModule or ToolTrigger or ToolRemote)
				rfalse;
			print_ret (CCNom) noun, "  ", (V2bEnd) noun, "  .";
	],
	data_cache 0 0,
	save_pos [ ptr;
		ptr = self.&data_cache;
		ptr-->0 = parent(self);
		if (ptr-->0 ~= activeplayer)
			print "    ! []^";
		ptr-->1 = (self has open);
	],
	restore_pos [ ptr;
		ptr = self.&data_cache;
		set_parent(self, ptr-->0);
		set_attribute(self, open, ptr-->1);
	],
	escape_pos [ loc;
		set_parent(self, loc);
		give self open;
	],
  has container openable ~open male;

Object toolcasefoam "/  "
  with
	name '' '' '',
	description [;
		"           ,    .";
	],
	before [;
		Take:
			"      .";
		Search:
			<<Examine toolcasehollows>>;
		Empty, EmptyT:
			<<(action) toolcase second>>;
		Receive:
			<<Insert noun toolcase>>;
	],
  has scenery female;

Object toolcasehollows "/"
  with
	name '',
	description [ fn;
		if (escaping) {
			"       (, ,   ),   (, , ,  ,  ),     .   ,     ,    ?";
		}
		if (self hasnt general) {
			give self general;
			fn = emphstring;
		}
		else {
			fn = normstring;
		}
		fn("      .");
		new_line;
		rtrue;
	],
	before [;
		Touch, Search:
			<<Examine self>>;
		Take:
			<<(action) toolcasefoam>>;
		Empty, EmptyT:
			<<(action) toolcase second>>;
		Receive:
			<<Insert noun toolcase>>;
	],
  has scenery pluralname ~general;	! general means italic warning done

Object lockpick "/"
  with
	name '' '' '' '' '',
	description [;
		print "  ,      -- ,  ,     ,      .       ";
		if (self.work_target) {
			print ",    ", (cPre) self.work_target;
			if (self hasnt general) {
				print ".    .^";
			}
			else {
				print ".   ";
				switch (self.work_timer) {
					4, 3: print " .^";
					2: print " -.^";
					1: print "  .^";
					default: print "  . [].^";
				}
			}
		}
		else {
			print "     ,   .    .^";
		}
		rtrue;
	],
	describe [;
		if (self.work_target) {
			print "^   ", (cPre) self.work_target, 
				".^";
			rtrue;
		}
		rfalse;
	],
	shortout "  .      .",
	before [ res;
		SwitchOn, SwitchOff:
			if (self has general)
				"  .";
			"    ,    ,     .";
		Touch, Rub:
			" ,    ,      .";
		Pull:
			if (self.work_target)
				<<Take self>>;
		Detach:
			if (self.work_target == nothing)
				rfalse;
			if (second && second ~= self.work_target)
				print_ret "    ", (cDat) second, ".";
			<<Take self>>;
		Insert, PutOn:
			if (second == toolcase or toolcasefoam or toolcasehollows)
				rfalse;
			if (second == tossend)
				rfalse;
			if (second has supporter)
				rfalse;
			if (second has container && ~~(second ofclass ToolModule))
				rfalse;
			<<BaseTouchTo self second>>;
		Connect:
			if (self has general)
				print_ret "    ", 
					(cDat) self.work_target, ".";
			if (self.work_target)
				print_ret " -   ", 
					(cDat) self.work_target, ".";
			<<ActivateTool self second>>;
		ActivateTool:
			if (self has general || self.work_target)
				" ! []";
			if (second == self or lockpick_disc)
				" ,   .";
			if (second ofclass ContactPad) {
				res = second.is_active(0);
				print "    ", (cDat) second, ",   ";
				if (res == 0)
					print "   . ";
				else
					print "    . ";
				second.is_active(1);
				rtrue;
			}
			if (second ~= outerdoorplate && ~~(second ofclass InteriorPlate)) {
				print_ret "     ", (cAcc) second, 
					",         .";
			}
			if (second ofclass InteriorPlate) {
				res = second.startup();
				if (res)
					rtrue;
			}
			move self to location;
			ShiftToEnd(self);
			self.work_target = second;
			self.work_timer = 4;
			StartDaemon(self);
			give self general;
			print_ret "    ", (cDat) self.work_target, 
				".      .";
	],
	after [;
		Take:
			if (self.work_target) {
				if (self has general) {
					self.shutdown();
					"     .      ,    .";
				}
				else {
					self.work_target = nothing;
					"     .";
				}
			}
	],
	daemon [ targ res oldac;
		if (player == passiveplayer) {
			print "^       ! []^";
			StopDaemon(self);
			return;
		}
		self.work_timer--;
		if (self.work_timer > 0 && self.work_timer < 3) {
			if (self in location) {
				print "^       .^";
			}
		}
		if (self.work_timer == 0) {
			targ = self.work_target;
			self.shutdown(1);
			if (targ ~= labdoorplate) {
				if (powercut) {
					if (self in location) {
						print "^     -,     .     .^";
					}
					rtrue;
				}
			}
			else {
				! it *is* the labdoorplate
				if (labdoor has locked) {
					if (self in location) {
						print "^     -,     .     .^";
					}
					rtrue;
				}
			}
			if (self in location) {
				print "^     -       .^";
			}
			if (targ ofclass InteriorPlate) {
				if (targ.work_target) {
					oldac = action;
					action = ##ActivateTool;
					res = RunRoutines(targ.work_target, before);
					action = oldac;
					if (res)
						rtrue;
				}
				if (escaping) {
					print "^ , @<<  ",
						(cAcc) targ.work_target, ",  @>>. []^";
				}
				else {
					print "^ , @<<  ", 
						(cAcc) targ.work_target, "@>>. []^";
				}
				rtrue;
			}
			switch (targ) {
				outerdoorplate:
					StartDaemon(outerdoorplate);
				default:
					print "^ , @<<    ", (cNom) targ, "?@>> []^";
			}
		}
	],
	shutdown [ flag;	! flag means don't wipe work_target
		StopDaemon(self);
		give self ~general;
		if (flag == 0)
			self.work_target = nothing;
	],
	! thing stuck to; if ~general, it's finished and ready to be removed
	work_target nothing,	
	work_timer 0,
	data_cache 0,
	save_pos [ ptr;
		ptr = self.&data_cache;
		ptr-->0 = parent(self);
		! save state is always detached and non-working
		if (self has general)
			print " ,   ! []^";
	],
	restore_pos [ ptr;
		ptr = self.&data_cache;
		set_parent(self, ptr-->0);
		give self ~general;
		self.work_target = 0;
	],
	escape_pos [ loc;
		set_parent(self, loc);
		give self ~general;
		self.work_target = 0;
	],
  has transparent connector female;	! general means stuck-on and working (and daemon)

Object lockpick_disc "/   " lockpick
  with
	name '' '' '' '',
	description "       ,       .",
	before [;
		Touch, Rub:
			"     .";
		Insert, PutOn, TouchTo:
			<<BaseTouchTo lockpick second>>;
	],
  has scenery connector female;

! ------------- Tool-module classes

Class ToolModule
  with
	name '' '',
	color_name "mauve",
	color_name_f "mauve",
	color_name_i "mauve",
	color_word 'mauve',
	work_target nothing,
	!parse_name [ num wd;
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, self, name) ~= 0) || (wd == self.color_word)) {
	!		num++;
	!		wd = NextWord();
	!	} 
	!	return num;
	!],
	show_status [;
		if (self.work_target == nothing)
			print ".";
		else
			print ",    ", 
				(cDat) self.work_target, ".";
		rtrue;
	],
	invent [;
		if (inventory_stage == 2) {
			if (self.work_target)
				print " (", (SAEnd) self, "  ", (cDat) self.work_target, ")";
			rtrue;
		}
	],
	partinvent [;
		if (inventory_stage == 2) {
			if (self.work_target)
				print " (", (SAEnd) self, "  ", (cDat) self.work_target, ")";
			rtrue;
		}
	],
	before [;
		Connect:
			if (second == self)
				"     .";
			if (self.work_target)
				print_ret (CCNom) self, "  ", (SAEnd) self, "  ",  
					(cDat) self.work_target, ".";
			if (second ofclass ToolModule)
				"   @<<@>>.";
			if (second ofclass ToolRemote)
				<<Connect second self>>;
			if (~~(second ofclass ToolTrigger)) 
				rfalse;
			<<Connect second self>>;
		Receive, Empty, EmptyT:
			print_ret " ", (cAcc) self, "   .";
		Search:
			"    .";
		PutOn, Insert:
			if (second == self)
				rfalse;
			if (second ofclass ToolModule || second ofclass ToolTrigger)
				<<Connect self second>>;
		LetGo:
			if (self.work_target && noun == self.work_target) {
				! <<Disconnect noun self>>; ! treat as a pure bug, for now
			}
			print_ret " ", (cNom) noun, "   ", (cPre) self, "? []";
		Detach:
			if (self.work_target == nothing)
				print_ret (CCNom) self, "     ", (SAEnd) self, ".";
			if (second && self.work_target ~= second)
				print_ret (CCNom) self, " ", (SAEnd) self, "  ", (cDat) self.work_target,
					",    ", (cDat) second, ".";
			<<Disconnect self.work_target self>>;
		SwitchOn, SwitchOff, Turn:
			print_ret " ", (cGen) self, "   .";
	],
	after [;
		Take:
			if (self.work_target)
				print_ret "  ", (cAcc) self, " ( ", (cAcc) self.work_target,
					", ", (AEnd) self.work_target, " ", (SAEnd) self.work_target, "  ", (DatIt2) self, ".)";
		Drop:
			if (self.work_target) {
				if (verb_word == '')
					print " ";
				else
					print " ";
				print_ret " ", (cAcc) self, " ( ", (cAcc) self.work_target,
					", ", (AEnd) self.work_target, " ", (SAEnd) self.work_target, "  ", (DatIt2) self, ".)";
			}
	],
	mod_start [ stayon blank;
		if (blank) new_line;
		if (stayon)
			print_ret (CCNom) self, " . []";
		else
			print_ret (CCNom) self, "   . []";
	],
	mod_stop [ blank;
		if (blank) new_line;
		print_ret (CCNom) self, " . []";
	],
	data_cache 0 0 0 0,
	save_pos [ ptr;
		ptr = self.&data_cache;
		ptr-->0 = parent(self);
		ptr-->1 = self.work_target;
	],
	restore_pos [ ptr;
		ptr = self.&data_cache;
		set_parent(self, ptr-->0);
		self.work_target = ptr-->1;
	],
	escape_pos [ loc;
		set_parent(self, loc);
		self.work_target = 0;
		loc = 0;
	],
  has connector open container;

Class ToolTrigger
  with
	name '' '',
	work_target nothing,
	!parse_name [ colwd num wd;
	!	if (self.work_target)
	!		colwd = self.work_target.color_word;
	!	else
	!		colwd = 'black';
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, self, name) ~= 0) || (wd == colwd)) {
	!		num++;
	!		wd = NextWord();
	!	} 
	!	return num;
	!],
	show_status [;
		if (self.work_target)
			print "    ", (cDat) self.work_target, ".";
		rtrue;
	],
	before [ ix;
		Connect:
			if (second == self)
				"     .";
			if (self.work_target)
				print_ret (CCNom) self, "  ", (SAEnd) self, "  ",  
					(cDat) self.work_target, ".";
			if (second ofclass ToolTrigger)
				"   @<<@>>.";
			if (second ofclass ToolRemote)
				<<Connect second self>>;
			if (~~(second ofclass ToolModule)) 
				rfalse;
			if (second.work_target)
				print_ret (CCNom) self, "  ", (SAEnd) self, "  ",  
					(cDat) self.work_target, ".";
			self.work_target = second;
			second.work_target = self;
			ix = PickToolLocation(parent(self), parent(second));
			move self to second;
			move second to ix;
			print "  ", (cAcc) self, "  ", (cDat) second, ". ",
				(CCNom) self, " ", (V1bEnd) self, " ", (string) second.color_name_i, 
				",   ";
			if (self provides link_target) {
				ix = self.link_target;
				if (visiblein(ix, location))
					print ",  ", (cNom) ix, "  ", (V1bEnd) self, " ",
						(string) second.color_name_i, "";
			}
			print ".^";
			ix = self.is_active();
			if (ix) {
				new_line;
				(self.work_target).mod_start(1);
			}
			rtrue;
		Disconnect:
			if (second ~= self.work_target)
				print_ret (CCNom) second, "  ", (SAEnd) self, "  ", (cAcc) self, "! []";
			if (self ~= second.work_target)
				print_ret (CCNom) self, "  ", (SAEnd) self, "  ", (cAcc) second, "! []";
			if (self notin second)
				print_ret (CCNom) second, "  ", (V2bEnd) second, "  ", (cGen) self, "! []";
			self.work_target = nothing;
			second.work_target = nothing;
			move self to player;
			print "  ", (cAcc) second, 
				"  ", (cGen) self, ",  ", (cNom) self, " ", (V1aEnd) self;
			if (self provides link_target) {
				ix = self.link_target;
				if (visiblein(ix, location))
					print ". ", (CCNom) ix, "  ", (V1aEnd) self;
			}
			print ".^";
			ix = self.is_active();
			if (ix) {
				new_line;
				second.mod_stop();
			}
			rtrue;
		PutOn, Insert:
			if (second == self)
				rfalse;
			if (second ofclass ToolModule || second ofclass ToolTrigger)
				<<Connect self second>>;
			if (self.work_target ~= nothing)
				<<(action) self.work_target second>>;
		Detach:
			if (self.work_target == nothing)
				print_ret (CCNom) self, "     ", (SAEnd) self, ".";
			if (second && self.work_target ~= second)
				print_ret (CCNom) self, " ", (SAEnd) self, "  ", (cDat) self.work_target,
					",    ", (cDat) second, ".";
			<<Disconnect self self.work_target>>;
		Remove:
			if (self.work_target && second == self.work_target) {
				<<Disconnect self self.work_target>>;
			}
		Take:
			if (self.work_target ~= nothing) {
				if (onotheld_mode)
					print "(", (AEnd) self,  "  ", (cDat) self.work_target, ")^";
				<<Take self.work_target>>;
			}
		Drop:
			if (self.work_target ~= nothing) {
				<<Drop self.work_target>>;
			}
	],
	is_active 0, ! function, returns whether the trigger is "on"
	data_cache 0 0 0 0,
	save_pos [ ptr;
		ptr = self.&data_cache;
		ptr-->0 = parent(self);
		ptr-->1 = self.work_target;
	],
	restore_pos [ ptr;
		ptr = self.&data_cache;
		set_parent(self, ptr-->0);
		self.work_target = ptr-->1;
	],
	escape_pos [ loc;
		set_parent(self, loc);
		self.work_target = 0;
		loc = 0;
	],
  has connector;

Class ToolRemote
  with
	!parse_name [ colwd num wd;
	!	if (self.link_target.work_target)
	!		colwd = self.link_target.work_target.color_word;
	!	else
	!		colwd = 'black';
	!	num = 0;
	!	wd = NextWord();
	!	while ((WordInProperty(wd, self, name) ~= 0) || (wd == colwd)) {
	!		num++;
	!		wd = NextWord();
	!	} 
	!	return num;
	!],
	link_target nothing,
	before [;
		Connect:
			print_ret " ", (cGen) self, "  , ", (PronounS) self, "   ",
				(cAcc) self.link_target, ".";
	],
	data_cache 0 0 0 0,
	save_pos [ ptr;
		ptr = self.&data_cache;
		ptr-->0 = parent(self);
	],
	restore_pos [ ptr;
		ptr = self.&data_cache;
		set_parent(self, ptr-->0);
	],
	escape_pos [ loc;
		set_parent(self, loc);
		loc = 0;
	],
  has connector;

! ------------- Tool modules

Object blasttab "/"
  class ToolModule,
  with
	name '' '' '' '', 
	color_name "",
	color_name_f "",
	color_name_i "",
	color_word '',
	description [;
		print "   ,      ,         .         ";
		self.show_status();
		new_line;
		rtrue;
	],
	answer_general [;
		if (performing_daemons) {
			! timed event, no special message
			print "";
		}
		else if (anywherein(self, player)) {
			! suicide, no special message.
			print "";
		}
		else {
			if (action == ##Connect)
				print "    ,   ";
			else if (self.work_target == pushbutton or toggleswitch 
				or timerswitch) 
				print "  ,   ";
			else
				print "";
		}
		return " ";
	],
	mod_start [ stayon blank   par subrock;
		stayon = 0;
		if (blank) new_line;
		
		if (escaping) {
			! We can simplify a little, because we're in the East Zone -- 
			! no labdoorstruts or panelcache. Also, there's no remote 
			! trigger left (radio broken, voice used up, timer buggered.)
			if (anywherein(self, powernode)) {
				if (location == WiringCloset)
					print (emphstring) "!", " ", 
						(string)self.answer_general(), 
						",   .^";
				else
					print "-     .^";
				CutOffPower();
				rtrue;
			}
			if (anywherein(self, player)) {
				print (emphstring) "!", " ", (string)self.answer_general();
				if (anywherein(self, toolcase)) 
					print "     ";
				print "    ";
				print ".    ,     ,        .^";
				deadflag = 1;
				rtrue;
			}
			print (emphstring) "!", " ", (string)self.answer_general(), 
				".^";
			remove blasttab;
			rtrue;
		}
		
		subrock = 0;
		
		par = self;
		while ((par ~= panelcache or labdoorstruts) && parent(par) ~= nothing) {
			par = parent(par);
		}
		
		if (par == panelcache) {
			subrock = 1;
		}
		else if (par == labdoorstruts) {
			subrock = 3;
		}
		
		if (par == panelcache && location == CeilingHole) {
			print "    ,      .";
			if (player in panelhole)
				print "       ,      .";
			new_line;
		}
		else if (par == labdoorstruts && location == OutsideLab) {
			print (emphstring) "!", " ", (string)self.answer_general(),
				"       .     --   ,     ...^";
		}
		else if (~~(par == location || anywherein(par, location))) {
			print "-     .^";
		}
		else {
			if (anywherein(self, player)) {
				print (emphstring) "!", " ", (string)self.answer_general();
				if (anywherein(self, toolcase)) 
					print "     ";
				print "    ";
				print ".    ,     ,        .^";
				print "^    ";
				print (emphstring) "***";
				print (emphstring) "   ";
				print (emphstring) "***";
				print "^";
				subrock = 2;
			}
			else {
				print (emphstring) "!", " ", (string)self.answer_general();
				if (anywherein(self, toolcase)) {
					print ",         .^";
				}
				else if (self in hypervent) {
					print ",         .^";
				}
				else {
					print ",   ";
					if (self in officedesk or officebookcase or interrealdesk
						or interrealchair or storetable) {
						print "  ";
					}
					else if (self in finaldrawer) {
						print "    ";
					}
					else if (self in finalcabinet) {
						print "     ";
					}
					else {
						print "  ";
					}
					print "      .^";
				}
			}
		}
		
		EndScene(-2, subrock);
		rtrue;
	],
	escape_pos [ loc;
		self.ToolModule::escape_pos(loc);
		self.work_target = radiomodule;
		set_parent(self, powernode);
	],
has female;

Object acidpack "/ /"
  class ToolModule,
  with
	name '' '' '' '' '' '' '', 
	! article "an",
	color_name "",
	color_name_f "",
	color_name_i "",
	color_word '',
	description [;
		print "   ,   .     @<<@>>    ,      ,  ,      .";
		if (self.number == 1)
			print " (, .    .)";
		self.number++;
		print "        ";
		self.show_status();
		new_line;
		rtrue;
	],
	mod_stop [ blank;
		if (blank) new_line;
		if (escaping) {
			"   . ,   .";
		}
		print_ret " . []";
	],
	mod_start [ stayon blank   par ix jx flag subrock;
		stayon = 0;
		if (blank) new_line;
		
		if (escaping) {
			"   . ,   .";
		}
		
		subrock = 0;
		
		par = self;
		while ((par ~= panelcache or hypervent) && parent(par) ~= nothing) {
			par = parent(par);
		}
		
		if (par == panelcache) {
			subrock = subrock | 4;
		}
		else if (par == OutsideLab) {
			subrock = -1;
		}
		else if (par == SecurityOffice) {
			subrock = -2;
		}
		else if (par == SecurityStorage) {
			subrock = -3;
		}
		else if (par == InterrogRoomReal) {
			subrock = -4;
		}
		
		if (par == panelcache && location == CeilingHole) {
			print "     ,       .^";
		}
		else if (par == hypervent && location == FinalEnd) {
			print "     ,       .^";
		}
		else if (par == OutsideLab && location == OutsideLab) {
			print "     .    ,     -- ,     .^";
		}
		else if (par == SecurityOffice && location == SecurityOffice) {
			print "     .    .       ,         .^";
		}
		else if (par == SecurityStorage && location == SecurityStorage) {
			print "     .    .     ,   ,       .^";
		}
		else if (par == FinalEnd && location == FinalEnd) {
			print "     .    . ",
				(CCNom) finaldoor, "    ,     .   , ,      .^";
		}
		else if (par == InterrogRoomReal && location == InterrogRoomReal) {
			print "     .    .     ,      .  ,        ,         ,   .^";
		}
		else if (~~(par == location || anywherein(par, location))) {
			print "-      .^";
		}
		else {
			print "     .";
			if (anywherein(self, toolcase) && toolcase hasnt open) 
				print "        ";
			else if (self in player)
				print " , ,    ,  ";
			else
				print " ";
			print "   .";
			
			flag = 0;
			if (anywherein(boltwrench, par)) {
				flag = 1;
				print "^^ ,    ,   ,    , , .";
				subrock = subrock | 2;
			}
			jx = nothing;
			objectloop (ix in par) {
				if (ix ofclass InteriorDoor || ix == outerdoorin)
					jx = ix;
			}
			if (jx) {
				if (flag == 0) {
					print "^^";
					flag = 1;
				}
				else {
					print " ";
				}
				print (CCNom) jx, "    ,  ,     ,    .     .";
				SeenDoorsPitted = 1;
				subrock = subrock | 1;
			}
			
			if (flag == 0) {
				print "   ,     .";
			}
			
			print "^^    .^";
		}
		
		EndScene(-1, subrock);
		rtrue;
	],
	number 0,
	escape_pos [ loc;
		self.ToolModule::escape_pos(loc);
		self.work_target = voicemodule;
		set_parent(self, nothing); ! blowed up
	], has male;

Object scrambler "/"
  class ToolModule,
  with
	name '' '' '' '', 
	color_name "",
	color_name_f "",
	color_name_i "",
	color_word 'orange',
	description [;
		print "      .          ... ,   ,  .";
		if (self has general && ~~self.fried)
			print "      .";
		if (self.fried)
			print " ,  ,    . ,        .";
		print "         ";
		self.show_status();
		new_line;
		rtrue;
	],
	fried false,
	before [;
		Touch:
			if (self has general && ~~self.fried)
				"   .";
		Smell:
			if (self.fried)
				"     .";
		Listen:
			if (self has general && ~~self.fried)
				"  .";
	],
	mod_start [ stayon blank;
		if (stayon) {
			give self general;
			if (visiblein(self, location)) {
				if (blank) new_line;
				if (self.fried)
					"    .";
				else
					"     ,       .";
			}
		}
		else {
			if (visiblein(self, location)) {
				if (blank) new_line;
				if (self.fried)
					"    .";
				else
					"       .";
			}
		}
	],
	mod_stop [ blank;
		give self ~general;
		if (visiblein(self, location)) {
			if (blank) new_line;
			if (self.fried)
				"    .";
			else
				" ,     .";
		}
	],
	save_pos [ ptr;
		self.ToolModule::save_pos();
		ptr = self.&data_cache;
		ptr-->2 = (self has general);
	],
	restore_pos [ ptr;
		self.ToolModule::restore_pos();
		ptr = self.&data_cache;
		set_attribute(self, general, ptr-->2);
		self.fried = false;
	],
	escape_pos [ loc;
		self.ToolModule::escape_pos(loc);
		give self ~general;
		self.work_target = timerswitch;
	],
  has ~general male; 	! general means turned on

Object minilight "/"
  class ToolModule,
  with
	name '' '' '' '' '' '' '' '', 
	short_name [;
		if (self has general)
			print " ";
		rfalse;
	],
	color_name "",
	color_name_f "",
	color_name_i "",
	color_word '',
	description [;
		print "          ";
		if (self has general)
			print ",    ";
		print ".       ";
		self.show_status();
		new_line;
		rtrue;
	],
	before [;
		Search:
			if (self has general)
				"    .";
			else
				"   . ,   .";
	],
	mod_start [ stayon blank;
		if (stayon) {
			give self general;
			if (visiblein(self, location)) {
				if (blank) new_line;
				"  .";
			}
		}
		else {
			if (visiblein(self, location)) {
				if (blank) new_line;
				"      .";
			}
		}
	],
	mod_stop [ blank;
		give self ~general;
		if (visiblein(self, location)) {
			if (blank) new_line;
			" .";
		}
	],
	save_pos [ ptr;
		self.ToolModule::save_pos();
		ptr = self.&data_cache;
		ptr-->2 = (self has general);
	],
	restore_pos [ ptr;
		self.ToolModule::restore_pos();
		ptr = self.&data_cache;
		set_attribute(self, general, ptr-->2);
	],
	escape_pos [ loc;
		self.ToolModule::escape_pos(loc);
		give self ~general;
	],
  has ~general male; 	! general means lit

Object pushbutton "/"
  class ToolTrigger,
  with
	name '' '',
	description [;
		print "  ";
		ColorTarget(self.work_target, 'f');
		print " ,       ,    --    .";
		self.show_status();
		new_line;
		rtrue;
	],
	before [;
		Push, SwitchOn:
			if (self.work_target == nothing)
				"     ,    ", (cNom) self, "     ,     .";
			(self.work_target).mod_start(0);
			rtrue;
		SwitchOff:
			"    .";
	], has female;

Object toggleswitch "/"
  class ToolTrigger,
  with
	name '' '' '' '',
	description [;
		print "  ";
		ColorTarget(self.work_target, 'f');
		print "              .";
		self.show_status();
		if (self has general)
			print "  .";
		else
			print "  .";
		new_line;
		rtrue;
	],
	before [;
		Push, Turn:
			if (self has general)
				<<SwitchOff self>>;
			else
				<<SwitchOn self>>;
		SwitchOn:
			if (self has general)
				"  .";
			give self general;
			print "  ";
			ColorTarget(self.work_target);
			print " . ";
			if (self.work_target == nothing)
				"     ,         ,     .";
			(self.work_target).mod_start(1);
			rtrue;
		SwitchOff:
			if (self hasnt general)
				"  .";
			give self ~general;
			print "  ";
			ColorTarget(self.work_target);
			print " . ";
			if (self.work_target == nothing)
				"     ,         ,     .";
			(self.work_target).mod_stop();
			rtrue;
	],
	is_active [;
		if (self has general)
			rtrue;
		rfalse;
	],
	save_pos [ ptr;
		self.ToolTrigger::save_pos();
		ptr = self.&data_cache;
		ptr-->2 = (self has general);
	],
	restore_pos [ ptr;
		self.ToolTrigger::restore_pos();
		ptr = self.&data_cache;
		set_attribute(self, general, ptr-->2);
	],
	escape_pos [ loc;
		self.ToolTrigger::escape_pos(loc);
		give self ~general;
	],
  has ~general male; 	! general means switched on.

Object timerswitch "/"
  class ToolTrigger,
  with
	name '' '' '' '',
	description [ flag;
		if (verb_word ~= '') {
			print " --   ";
			ColorTarget(self.work_target, 'f');
			print "              .";
			self.show_status();
			print " ";
		}
		print "   ";
		if (self has general)
			print ".";
		else
			print ".";
		if (timerdialon.number == timerdialoff.number)
			print "  ,      ", 
				timerdialon.number, ";";
		else
			print "     ", timerdialon.number, 
				",   --  ", timerdialoff.number, ";";
		switch (self.number) {
			1:
				!print " the ";
				if (self hasnt general)
					print "";
				else
					print "";
				print "  .";
				flag = 1;
			2:
				print "   .";
				flag = 1;
		}
		!if (flag == 0)
		!	print " the ";
		!else
		!	print " The ";
		if (self.number == 0) {
			if (flag == 0)
				print " ";
			else
				print " ";
			print "  .";
		} else{
			if (flag == 0)
				print " ";
			else
				print " ";
			print "    ", self.work_timer, ".";
		}
		new_line;
		rtrue;
	],
	before [ ix;
		Set, SetTo:
			"      .";
		ActivateTool:
			give self general;
			if (self.work_target == nothing) {
				if (visiblein(self, location))
					print "   ,         ,     .^";
			}
			else {
				ix = (self.work_target).mod_start(1, second);
				if (ix == 0) {
					if (visiblein(self, location))
						print "   .^";
				}
			}
			rtrue;
		DeactivateTool:
			give self ~general;
			if (self.work_target == nothing) {
				if (visiblein(self, location))
					print "   ,         ,     .^";
			}
			else {
				ix = (self.work_target).mod_stop(second);
				if (ix == 0) {
					if (visiblein(self, location))
						print "   .^";			
				}
			}
			rtrue;
	],
	number 0, 
	! number means state: 
	!	0 = not running (daemon off)
	!	1 = running (daemon on, going to switch)
	!	2 = running (daemon on, going to alternate)
	work_timer 0,	! current value 
	number2 5, ! failure counter for dials
	daemon [ vis ix;
		if (player == passiveplayer) {
			print "^      ! []^";
			self.number = 0;
			StopDaemon(self);
			return;
		}
		if (self.number == 0)
			"^    ! []";
		if (self.work_timer >= 1000) {
			! first turn, no decrement or effect
			self.work_timer = self.work_timer - 1000;
			rtrue;
		}
		vis = visiblein(self, location);
		self.work_timer--;
		if (self.work_timer <= 0) {
			if (self.number == 2) {
				if (self has general) {
					ix = timerdialon;
				}
				else {
					ix = timerdialoff;
				}
				if (vis)
					print "^", (CCNom) ix, "  ,    ", ix.number, ". ";
				self.work_timer = ix.number;
			}
			else {
				self.number = 0;
				StopDaemon(self);
				if (vis)
					print "^   . ";
			}		
			if (self has general)
				<<DeactivateTool self ~~vis>>;
			else
				<<ActivateTool self ~~vis>>;
			rtrue;
		}
		if (vis)
			print "^   ", self.work_timer, ".^";
	],
	daemon_priority -5,
	is_active [;
		if (self has general)
			rtrue;
		rfalse;
	],
	data_cache 0 0 0 0 0,
	save_pos [ ptr;
		self.ToolTrigger::save_pos();
		ptr = self.&data_cache;
		ptr-->2 = (self has general);
		ptr-->3 = timerdialon.number;
		ptr-->4 = timerdialoff.number;
		if (self.number ~= 0) {
			print " , @<< !@>> []^";
		}
	],
	restore_pos [ ptr;
		self.ToolTrigger::restore_pos();
		ptr = self.&data_cache;
		set_attribute(self, general, ptr-->2);
		timerdialon.number = ptr-->3;
		timerdialoff.number = ptr-->4;
	],
	escape_pos [ loc;
		self.ToolTrigger::escape_pos(loc);
		self.work_target = scrambler;
		move self to scrambler;
		give self ~general;
		timerdialon.number = 18;
		timerdialoff.number = 1;
		self.number = 0;
		self.work_timer = 0;
	],
  has transparent ~general male; 	! general means output is on

! The rule here: you can twiddle dials as you like; you don't get a countdown
! until you press the dial. If one dial is running, it's in the opposite state,
! and goes to the dial's state when the dial runs out. If you press the running
! dial, it stops (and the indicator vanishes.) If you press the non-running dial,
! it goes on, and you then get alternation. Press the non-running dial again,
! it shorts to that state of the alternation.

Class TimerDial
  with
	name '',
	number 1,		! limit value (1..n)
	link_target 0,	! the other dial
	is_active 0,	! returns whether the timer is *not* in this dial's state.
	set_active 0,	! set timer to this dial's state.
	description [;
		print_ret (CCNom) self, "   ", self.number, ".";
	],
	before [ oth;
		Set, Turn:
			"      1  20.";
		SetTo:
			if (second < 1 || second > 20)
				<<Set self>>;
			self.number = second;
			print "  ", (cAcc) self, "  ", second, ".";
			if (heard_timer_warning == 0) {
				print " (  ,   .)";
				heard_timer_warning = 1;
			}
			new_line;
			rtrue;
		Push:
			if (escaping) {
				if (timerswitch.number2 >= 0) {
					timerswitch.number2 = -1;
					"   --    ,      . ,    .";
				}
				else {
					"    .";
				}
			}
			if (random(11) < timerswitch.number2) {
				timerswitch.number2 = 1;
				print "  .    ,  , , . ";
			}
			else {
				timerswitch.number2 = timerswitch.number2 + 2;
			};
			oth = self.link_target;
			switch (timerswitch.number) {
				0:
					timerswitch.number = 1;
					timerswitch.work_timer = self.number + 1000;
					StartDaemon(timerswitch);
					print "  ", (cAcc) self, ",   .     ", self.number, ".";
					if (oth.is_active()) {
						!print " The status dot goes ", (string) oth.color_name, ". ";
						print " ";
						oth.set_active();
					}
					else {
						new_line;
					}
					rtrue;
				1:
					if (oth.is_active()) {
						timerswitch.number = 2;
						print_ret "  ", (cNom) self, ".";
					}
					else {
						timerswitch.number = 0;
						StopDaemon(timerswitch);
						print_ret (CCNom) self, " ,    - .";
					}
				2:
					timerswitch.number = 0;
					StopDaemon(timerswitch);
					print_ret "  ,     - .";
				default:
					"    ! []";
			}
	],
  has scenery;

Object timerdialon "/ /" timerswitch
  class TimerDial,
  with
	name '',
	color_name "",
	color_name_f "",
	color_name_i "",
	link_target timerdialoff,
	set_active [; <<ActivateTool timerswitch>>; ],
	is_active [;
		if (timerswitch hasnt general)
			rtrue;
		rfalse;
	],
has male;

Object timerdialoff "/ /" timerswitch
  class TimerDial,
  with
	name '',
	color_name "",
	color_name_f "",
	color_name_i "",
	link_target timerdialon,
	set_active [; <<DeactivateTool timerswitch>>; ],
	is_active [;
		if (timerswitch has general)
			rtrue;
		rfalse;
	],
has male;

Object radiomodule "/"
  class ToolTrigger,
  with
	name '' '' '' '' '' '',
	link_target keytrans,
	description [;
		print "  ";
		ColorTarget(self.work_target, 'f');
		print " ,        ,    --    .";
		self.show_status();
		new_line;
		rtrue;
	],
	escape_pos [ loc;
		self.ToolTrigger::escape_pos(loc);
		self.work_target = blasttab;
		move self to blasttab;
	],
has male;

Object voicemodule "/ /"
  class ToolTrigger,
  with
	name '' '' '' '' '',
	link_target voicetrans,
	description [;
		print "  ";
		ColorTarget(self.work_target, 'f');
		print " ,        ,    --    .";
		self.show_status();
		new_line;
		rtrue;
	],
	is_active [;
		if (voicetrans has general)
			rtrue;
		rfalse;
	],
	escape_pos [ loc;
		self.ToolTrigger::escape_pos(loc);
		self.work_target = acidpack;
		move self to acidpack;
	],
has male;

Object keytrans "/ /"
  class ToolRemote,
  with
	name '' '' '' '' '',
	link_target radiomodule,
	description [;
		print_ret "  ", (ColorTarget) radiomodule.work_target, "           .";
	],
	before [ flag;
		Push, SwitchOn:
			if (escaping) {
				"   .    ,   . ׸  - ,   ,   - .";
			}
			if (radiomodule.work_target == nothing) {
				if (visiblein(radiomodule, location)) {
					print "   .    ",
						(cPre) radiomodule, "    ,         ,     .^";
					flag = 1;
				}
				else {
					flag = 0;
				}
			}
			else {
				flag = (radiomodule.work_target).mod_start(0);
			}
			if (flag == 0) {
				print "  ,     ,      .^";
			}
			rtrue;
		SwitchOff:
			"   .";
	],
has male;

Object voicetrans "/ /"
  class ToolRemote,
  with
	name '' '' '' '' '' '' '' '',
	link_target voicemodule,
	description [;
		if (verb_word == 'read')
			<<Examine voicekeywords>>;
		print "  ", (ColorTarget) voicemodule.work_target, 
			"           .";
		print "   ";
		if (self has general)
			print " .";
		else
			print " .";
		print_ret "     .";
	],
	react_before [ ix;		! see react_before of toolcase
		Tango:
			<<ActivateTool self>>;
		Waltz:
			<<DeactivateTool self>>;
		VagueSay, Answer:
			if (consult_words >= 1) {
				wn = consult_from;
				ix = NextWord();
				if (ix == '~//' && consult_words >= 2) {
					ix = NextWord();
				}
				if (ix == '') {
					<<ActivateTool self>>;
				}
				if (ix == '') {
					<<DeactivateTool self>>;
				}
			}
	],
	orders [;
		Tango:
			<<ActivateTool self>>;
		Waltz:
			<<DeactivateTool self>>;
		default:
			" .";
	],
	before [ flag;
		ActivateTool:
			if (self has general) {
				if (visiblein(self, location))
					"   ,  ", (cNom) self, "  .";
				"   .";
			}
			give self general;
			if (voicemodule.work_target == nothing) {
				if (visiblein(voicemodule, location)) {
					print "   .   ", 
						(cGen) voicemodule, "    ,         ,     .^";
					flag = 1;
				}
				else {
					flag = 0;
				}
			}
			else {
				flag = (voicemodule.work_target).mod_start(1);
			}
			if (flag == 0) {
				if (visiblein(self, location))
					print "   ,     ,      .^";
				else
					print "   .^";
			}
			rtrue;
		DeactivateTool:
			if (self hasnt general) {
				if (visiblein(self, location))
					"   ,  ", (cNom) self, "  .";
				"   .";
			}
			give self ~general;
			if (voicemodule.work_target == nothing) {
				if (visiblein(voicemodule, location)) {
					print "   .   ", 
						(cGen) voicemodule, "    ,         ,     .^";
					flag = 1;
				}
				else {
					flag = 0;
				}
			}
			else {
				flag = (voicemodule.work_target).mod_stop();
			}
			if (flag == 0) {
				if (visiblein(self, location))
					print "   ,     ,      .^";
				else
					print "   .^";
			}
			rtrue;
	],
	save_pos [ ptr;
		self.ToolRemote::save_pos();
		ptr = self.&data_cache;
		ptr-->1 = (self has general);
	],
	restore_pos [ ptr;
		self.ToolRemote::restore_pos();
		ptr = self.&data_cache;
		set_attribute(self, general, ptr-->1);
	],
	escape_pos [ loc;
		self.ToolRemote::escape_pos(loc);
		give self general;
	],
  has transparent ~general talkable male;	! general means switched on

Object voicekeywords "/ /" voicetrans
  with
	name '' '' '',
	description "    -- @<<@>>    @<<@>>  . ,  ,    .",
	before [;
		Examine:
			rfalse;
		default:
			"     .";
	],
  has scenery pluralname;

! ------------- Functions

[ ColorTarget targ sex;

	if (targ == nothing) {
		if (sex == 'f') {
			print "";
		} else {
			print "";
		}
	}
	else if (~~(targ ofclass ToolModule)) {
		print "- []";
	}
	else {
		if (sex) {
			if (sex == 'f') {
				print (string) targ.color_name_f;
			} else {
				print (string) targ.color_name;
			}
		} else {
			print (string) targ.color_name;
		}
	}
];

[ PickToolLocation p1 p2    loc1 loc2;
	! The toolcase does not count as "local" if the player isn't
	! holding it.
	loc1 = (p1 == player || (p1 == toolcase && anywherein(toolcase, player)));
	loc2 = (p2 == player || (p2 == toolcase && anywherein(toolcase, player)));
	
	if (loc1) {
		if (loc2) {
			! both are
			if (p1 == player || p2 == player)
				return player;
			else
				return toolcase;	
		}
		! only p1
		return p2;
	}
	else {
		if (~~loc2) {
			! neither are
			return p2; ! the module, not the trigger
		}
		! only p2
		return p1;
	}
];

! Check to see if any tools were left behind (not in the player). This includes
! the Mysterious Package. If just one was, or a linked pair, return its value;
! if several, return 1.
! if snum >= 3, don't check the lockpick.
[ LeftToolsBehind snum target   ix ex num;
	if (target == 0)
		target = player;
		
	num = 0;
	if (~~anywherein(package, target)) {
		num++;
		ex = package;
	}
	if (~~anywherein(toolcase, target)) {
		num++;
		ex = toolcase;
	}
	if (snum < 3) {
		if (~~anywherein(lockpick, target)) {
			num++;
			ex = lockpick;
		}
	}
	objectloop (ix ofclass ToolTrigger) {
		if (~~anywherein(ix, target)) {
			! if linked, the parent will catch it, so don't bother.
			if (ix.work_target == 0) {
				num++;
				ex = ix;
			}
		}
	}
	objectloop (ix ofclass ToolModule) {
		if (~~anywherein(ix, target)) {
			num++;
			ex = ix;
		}
	}
	objectloop (ix ofclass ToolRemote) {
		if (~~anywherein(ix, target)) {
			num++;
			ex = ix;
		}
	}
	if (num == 0)
		return 0;
	if (num == 1)
		return ex;
	return 1;
];

[ StopAllTools;
	if (lockpick has general) {
		lockpick.shutdown();
	}
	if (timerswitch.number) {
		timerswitch.number = 0;
		StopDaemon(timerswitch);
	}
];

! record everything at an initial scene-begin; also ensure the timer is
! stopped, lockpick is disconnected and off, package is in right location, etc
[ SaveToolPositions   ix;
	package.save_pos();
	toolcase.save_pos();
	lockpick.save_pos();
	objectloop (ix ofclass ToolTrigger) {
		ix.save_pos();
	}
	objectloop (ix ofclass ToolModule) {
		ix.save_pos();
	}
	objectloop (ix ofclass ToolRemote) {
		ix.save_pos();
	}
];

! restore everything to saved positions. (ditto)
[ RestoreToolPositions   ix;
	package.restore_pos();
	toolcase.restore_pos();
	lockpick.restore_pos();
	objectloop (ix ofclass ToolTrigger) {
		ix.restore_pos();
	}
	objectloop (ix ofclass ToolModule) {
		ix.restore_pos();
	}
	objectloop (ix ofclass ToolRemote) {
		ix.restore_pos();
	}
];

! move everything to great-escape position, generally piled in loc.
[ EscapeToolPositions loc   ix;
	package.escape_pos(loc);
	lockpick.escape_pos(loc);
	toolcase.escape_pos(loc);
	objectloop (ix ofclass ToolTrigger) {
		ix.escape_pos(loc);
	}
	objectloop (ix ofclass ToolModule) {
		ix.escape_pos(loc);
	}
	objectloop (ix ofclass ToolRemote) {
		ix.escape_pos(loc);
	}
];

[ GiveInitialTools   ix;
	if (giveinittoolsflag)
		"    . []";
	giveinittoolsflag = 1;
	move toolcase to activeplayer;
	give toolcase open;
	move lockpick to activeplayer;
	objectloop (ix ofclass ToolRemote) {
		move ix to toolcase;
	}
	objectloop (ix ofclass ToolTrigger) {
		move ix to toolcase;
	}
	objectloop (ix ofclass ToolModule) {
		move ix to toolcase;
	}
];

#ifdef ZDEBUG;

[ ZapDoEquip   ix;
	move toolcase to player;
	give toolcase open;
	move lockpick to toolcase;
	objectloop (ix ofclass ToolTrigger) {
		if (ix.work_target == 0)
			move ix to toolcase;
	}
	objectloop (ix ofclass ToolModule) {
		move ix to toolcase;
	}
	objectloop (ix ofclass ToolRemote) {
		move ix to toolcase;
	}
];

#endif;

! ------------- Models and copies, for passive mode.

Object lockpick_model "/"
  with
	name '' '' '' '' '' '' '',
	short_name [;
		if (self hasnt general) {
			print " ";
			rtrue;
		}
	],
	description [;
		if (self hasnt general) {
			give self general;
		}
		",   .   ,    ;              .   ,      .";
	],
  has transparent ~general female;

Object lockpick_disc_model "/ " lockpick_model
  with
	name '' '' '' '' '',
	description "       ,       .",
  has scenery female;

Object poisonpen_model "/"
  with
	name '' '' '' '' '' '' '' ''
		'' '' '' '',
	description "  .   ,  ,     ,        .",
  has female;

! ------------- Questions and answers

[ SetAcidQuestions subrock;
	if (subrock < 0) {
		switch (subrock) {
			-1: ! on lab door
				if (q4_da1 hasnt general) {
					give q4_da1 general;
					SetQuestion(q4_da1);
				}
				else if (q4_da1r hasnt general) {
					give q4_da1r general;
					SetQuestion(q4_da1r);
				}
				else {
					SetQuestion(q4_da1rr);
				}
			-2: ! security office
				SetQuestion(q5_da1);
			-3: ! security storage
				SetQuestion(q5_da2);
			-4: ! security interrog
				SetQuestion(q5_da3);
			default:
				"-   , . []";
		}
	}
	else if (subrock & 4) {
		! acid in ceiling panel
		if (qn_a1 hasnt general) {
			give qn_a1 general;
			SetQuestion(qn_a1, 1);
		}
		else {
			SetQuestion(qn_a1r, 1);
		}
	}
	else if (subrock == 0) {
		! acid with no damage to anything
		if (qn_a1 hasnt general) {
			give qn_a1 general;
			SetQuestion(qn_a1, 0);
		}
		else {
			SetQuestion(qn_a1r, 0);
		}
	}
	else {
		! acid in general: subrock&1 means door damage, &2 means wrench gone
		if (qn_a2 hasnt general) {
			give qn_a2 general;
			SetQuestion(qn_a2, subrock);
		}
		else {
			SetQuestion(qn_a1r, subrock);
		}
	}
];

[ SetBlastQuestions subrock;
	! subrock 1 means it was in the ceiling; 2 means it killed you; 3 means
	! it was on the lab door.
	switch (subrock) {
		0, 1:
			if (qn_b1 hasnt general) {
				give qn_b1 general;
				SetQuestion(qn_b1, subrock);
			}
			else {
				SetQuestion(qn_b1r, subrock);
			}
		2:
			if (qn_b2 hasnt general) {
				give qn_b2 general;
				SetQuestion(qn_b2);
			}
			else if (qn_b2r hasnt general) {
				give qn_b2r general;
				SetQuestion(qn_b2r);
			}
			else if (qn_b2rr hasnt general) {
				give qn_b2rr general;
				SetQuestion(qn_b2rr);
			}
			else {
				print "^   . @<<     .  ,  @>>.      .^";
				BrainDrain();
			}
		3:
			if (q4_db1 hasnt general) {
				give q4_db1 general;
				SetQuestion(q4_db1);
			}
			else {
				SetQuestion(q4_db1r);
			}
		default:
			"  ? []";
	}
];

Object qn_a1
  class Question,
  with
	query [;
		print "^@<<,  .  ,        - @>>.   . @<<  -   .    ";
		if (self.variant)
			print "  ";
		else
			print " ";
		"?@>>";
	],
	time_limit 3,
	answer_yes [;
		num_sneaky_lies++;
		print "@<<,  ,    ",
			(emphstring) "", "      -?  ,   ,        @>>.^";
		BeginScene(-1);
	],
	answer_no [;
		print "@<<, .       @>>.    .^";
		BeginScene(-1);
	],
	answer_wait [;
		print "@<<,       .  ,   ,        @>>.    .^";
		BeginScene(-1);
	],
  has ~general; ! general means it's been asked

Object qn_a1r
  class Question,
  with
	query [;
		print "^@<< --  --          , ",
			(emphstring) "", "  .  ,     ,   @>>.     ,    .^";
		BeginScene(-1);
	];

Object qn_a2
  class Question,
  with
	query [;
		print "^  . @<<   ?@>>^";
	],
	time_limit 4,
	daemon [;
		if (self.number == 1) {
			print "^@<<,   @>>.^";
		}
	],
	answer_general [;
		num_blatant_lies++;
		print " --         ";
		if ((self.variant) & 1)
			print " --       ";
		if ((self.variant) & 2)
			print ".      ,   ";
		print "@>>.     .^";	
	],
	answer_yes [;
		num_helpfuls++;
		print "@<<.   -   .  , --  , ";
		self.answer_general();
		BeginScene(-1);
	],
	answer_no [;
		num_helpfuls++;
		print "@<<.   -    .  , --  , ";
		self.answer_general();
		BeginScene(-1);
	],
	answer_wait [;
		num_stubborns++;
		print "@<< ?     ?  , --  , ";
		self.answer_general();
		BeginScene(-1);
	],
  has ~general; ! general means it's been asked

Object qn_b1
  class Question,
  with
	query "^@<<      @>>, --  ,  .",
	time_limit 3,
	answer_yes [;
		num_blatant_lies++;
		print "@<<? ", (emphstring) "",
			"      ,         @>>.    .^";
		BeginScene(-2);
	],
	answer_no [;
		print "@<<,   ,     . ", (emphstring) "",
			"      ,         @>>.    .^";
		BeginScene(-2);
	],
	answer_wait [;
		num_stubborns++;
		print "@<<  @>> --  ,     . @<<", 
			(emphstring) "",
			"      ,         @>>.    .^";
		BeginScene(-2);
	],
  has ~general; ! general means it's been asked

Object qn_b1r
  class Question,
  with
	query [;
		print "^ . @<<   ,           ,     @>>.     ,    .^";
		BeginScene(-2);
	],
  has ~general; ! general means it's been asked

Object qn_b2
  class Question,
  with
	query "^     ,       ,      . @<<   @>>.",
	time_limit 1,
	answer_yes [;
		num_blatant_lies++;
		num_stubborns++;
		print "    .^";
		BeginScene(-2);
	],
	answer_no [;
		num_blatant_lies++;
		num_stubborns++;
		print "@<<, :    ,     ,  ,       ...@>>     .^";
		BeginScene(-2);
	],
	answer_wait [;
		num_stubborns++;
		print "    .^";
		BeginScene(-2);
	],
  has ~general; ! general means it's been asked

Object qn_b2r
  class Question,
  with
	query [;
		num_got_angry++;
		print "^@<<, ,  .   --  ,     .     ?@>>      .^";
		BeginScene(-2);
	],
  has ~general; ! general means it's been asked

Object qn_b2rr
  class Question,
  with
	query [;
		print "^@<<,  ,  ,          .  ,      @>>.      .^";
		BeginScene(-2);
	],
  has ~general; ! general means it's been asked

